Subject: Re: bug#24902: 25.1; C-x = for Unicode

From: Mattias Engdegård <[email-masked]>
Date: Tue, 25 Jan 2022 16:38:22 +0100

24 jan. 2022 kl. 18.39 skrev Lars Ingebrigtsen <[email-masked]>:

> Writing code is always better for programmers, but non-programmers can
> put together format-spec things easier.

Maybe, but why don't we first try to make an effort so that they don't have to. There is a tower of convenience for the typical user:

1. accept the default
2. customise-variable, picking another ready-made format
3. download an ELPA package (or copy someone's init.el)
4. write Lisp

A format-spec elaboration would fit somewhere between 3 and 4 in that tower -- easier than Lisp, but less convenient than using something available. (Maybe you would place it above 3, but then I personally rank "Lisp" at around 1.001. We aren't typical users.)

Thus let's attack 1 and 2 first. If we fail, and it is clear that a significant number of users would legitimately be dissatisfied by options 1..4 above, then format-spec may be an option.

>> 3. As any designer knows, customisability is a cop-out: it's an
>> abdication of responsibility. The user can now conveniently be blamed
>> for any perceived shortcoming. Conversely, being forced to think and
>> make hard choices is much of what design is about, and users like when
>> it's done for them in a competent way.
> 
> I know what you mean, but of course I want to have a good default.

And I know that you do! What about the new format -- is it good enough for you, or can you help making it better?

>  I just doubt that there's any point in adding more than one "standard
> format" -- people that want to tweak stuff like this really wants to
> tweak stuff like this.

No they don't, unless we tell them that they may want to. (This is an often ignored back-side of customisation!)
I've only heard rather reasonable comments about specific shortcomings such as the lack of Unicode names. Let's fix that first.

>  Trying to figure out all formats a user might
> want is futile (and ultimately user-hostile).

Correct, but that was never the the idea. We only need to provide the minimum number of ones to make most users happy.

(I should add at this point that users typically don't know exactly what they want, but they occasionally do know what they don't. This actually makes the job of the designer easier.)

The ideal number of options is always one, but I went with two for a very specific reason: the 'traditional' option is a time-saver. Not for users, but for you and me, who can point to it if there is a complaint about the change. I'd rather not have it.